#include <Ice/Ice.h>
#include <statstest.h>
#include <iostream>

using namespace std;
using namespace Demo;

class StatsClient : public Ice::Application
{
public:
	virtual int run(int argc, char* argv[]);
};

int main(int argc, char* argv[])
{
	StatsClient app;
	return app.main(argc, argv);
}

int StatsClient::run(int argc, char* argv[])
{
	if(argc > 1)
	{
		cerr << appName() << ": too many arguments" << endl;
		return EXIT_FAILURE;
	}

	statstestPrx twoway = statstestPrx::checkedCast(
		communicator()->stringToProxy("Stats:tcp -h 192.168.2.60 -p 10000")->ice_twoway()->ice_timeout(-1)->ice_secure(false));
	if(!twoway)
	{
		cerr << argv[0] << ": invalid proxy" << endl;
		return EXIT_FAILURE;
	}

	//The client invoke function 'getFile',getFile in the server side get the file from the other remote computer which stores the file.
	//The server only return true or false not return the file data.
	//The client only want to know the percent transmission int the server side.
	//What can I do?
	bool bSuccess = twoway->getFile("1.txt");

	return 1;
}