#include <iostream>
#include <Ice/Ice.h>
#include "statstest.h"
#include "MyStats.h"
#include "StatsServerI.h"

using namespace std;

class StatsServer : public Ice::Application
{
public:
	virtual int run(int argc, char* argv[]);
};

int main(int argc, char* argv[])
{
	Ice::InitializationData id;
	id.stats = new MyStats;

	StatsServer app;
	return app.main(argc, argv, id);
}

int StatsServer::run(int argc, char* argv[])
{
	if(argc > 1)
	{
		cerr << appName() << ": too many arguments" << endl;
		return EXIT_FAILURE;
	}

	Ice::ObjectAdapterPtr adapter = communicator()->createObjectAdapterWithEndpoints("StatsTest", "default -p 10000");
	Demo::statstestPtr statstest = new StatsServerI;
	adapter->add(statstest, communicator()->stringToIdentity("Stats"));
	adapter->activate();
	communicator()->waitForShutdown();
	return EXIT_SUCCESS;
}